Index: palm/trunk/SOURCE/transpose.f90
===================================================================
--- palm/trunk/SOURCE/transpose.f90	(revision 4901)
+++ palm/trunk/SOURCE/transpose.f90	(revision 1)
@@ -705,663 +343,349 @@
     DO  l = 0, pdims(1) - 1
        xs = 0 + l * nnx
-       DO  j = nys_x, nyn_x
-          DO  k = 1, nz
+       DO  j = nys_x, nyn_xa
+          DO  k = 1, nza
              DO  i = xs, xs + nnx - 1
                 m = m + 1
-                f_out(i,j,k) = work(m)
-             ENDDO
-          ENDDO
-       ENDDO
-    ENDDO
+                f_out(i,j,k) = work2(m)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
+#endif
 
  END SUBROUTINE transpose_yxd
-#endif
-
-
-!--------------------------------------------------------------------------------------------------!
+
+
+ SUBROUTINE transpose_yz( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Resorting data for the transposition from y to z. The transposition itself is carried out in
-!> transpose_yz.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE resort_for_yz( f_in, f_inv )
-
-
-    USE indices,                                                                                   &
-        ONLY:  ny
-
-    USE kinds
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxr_y,                                                                              &
-               nzb_y,                                                                              &
-               nzt_y
+! Transposition of input array (f_in) from y to z. For the input array, all
+! elements along y reside on the same PE, while after transposition, all
+! elements along z reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_in(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)   !<
-    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-    !$OMP PARALLEL PRIVATE ( i, j, k )
-    !$OMP DO
-#if __acc_fft_device
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-    !$ACC PRESENT(f_inv, f_in)
+    INTEGER ::  i, j, k, l, m, zs
+    
+    REAL ::  f_in(0:nya,nxl_y:nxr_ya,nzb_y:nzt_ya),                     &
+             f_inv(nxl_y:nxr_ya,nzb_y:nzt_ya,0:nya),                    &
+             f_out(nxl_z:nxr_za,nys_z:nyn_za,1:nza),                    &
+             work1(nxl_y:nxr_ya,nzb_y:nzt_ya,0:nya), work2(nnx*nny*nnz)
+
+#if defined( __parallel )
+
+!
+!-- Rearrange indices of input array in order to make data to be send
+!-- by MPI contiguous
+    DO  k = nzb_y, nzt_ya
+       DO  i = nxl_y, nxr_ya
+          DO  j = 0, nya
+             work1(i,k,j) = f_in(j,i,k)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to different array, because memory location of work1 is
+!-- needed further below (work1 = work2).
+!-- If the PE grid is one-dimensional along y, only local reordering
+!-- of the data is necessary and no transposition has to be done.
+    IF ( pdims(1) == 1 )  THEN
+       DO  j = 0, nya
+          DO  k = nzb_y, nzt_ya
+             DO  i = nxl_y, nxr_ya
+                f_out(i,j,k) = work1(i,k,j)
+             ENDDO
+          ENDDO
+       ENDDO
+       RETURN
+    ELSE
+       DO  j = 0, nya
+          DO  k = nzb_y, nzt_ya
+             DO  i = nxl_y, nxr_ya
+                f_inv(i,k,j) = work1(i,k,j)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- Transpose array
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+    CALL MPI_ALLTOALL( f_inv(nxl_y,nzb_y,0), sendrecvcount_yz, MPI_REAL, &
+                       work2(1),             sendrecvcount_yz, MPI_REAL, &
+                       comm1dx, ierr )
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!-- Reorder transposed array
+    m = 0
+    DO  l = 0, pdims(1) - 1
+       zs = 1 + l * ( nzt_ya - nzb_y + 1 )
+       DO  j = nys_z, nyn_za
+          DO  k = zs, zs + nzt_ya - nzb_y
+             DO  i = nxl_z, nxr_za
+                m = m + 1
+                f_out(i,j,k) = work2(m)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
-    DO  k = nzb_y, nzt_y
-        DO  i = nxl_y, nxr_y
-            DO  j = 0, ny
-               f_inv(i,k,j) = f_in(j,i,k)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP END PARALLEL
-
- END SUBROUTINE resort_for_yz
-
-
-!--------------------------------------------------------------------------------------------------!
+
+ END SUBROUTINE transpose_yz
+
+
+ SUBROUTINE transpose_zx( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Transposition of input array (f_in) from y to z. For the input array, all elements along y reside
-!> on the same PE, while after transposition, all elements along z reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_yz( f_inv, f_out )
-
+! Transposition of input array (f_in) from z to x. For the input array, all
+! elements along z reside on the same PE, while after transposition, all
+! elements along x reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k, l, m, xs
+    
+    REAL ::  f_in(1:nza,nys:nyna,nxl:nxra), f_inv(nxl:nxra,nys:nyna,1:nza), &
+             f_out(0:nxa,nys_x:nyn_xa,nzb_x:nzt_xa),                        &
+             work1(nxl:nxra,nys:nyna,1:nza), work2(nnx*nny*nnz)
 
 #if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
+
+!
+!-- Rearrange indices of input array in order to make data to be send
+!-- by MPI contiguous
+    DO  i = nxl, nxra
+       DO  j = nys, nyna
+          DO  k = 1,nza
+             work1(i,j,k) = f_in(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to different array, because memory location of work1 is
+!-- needed further below (work1 = work2).
+!-- If the PE grid is one-dimensional along y, only local reordering
+!-- of the data is necessary and no transposition has to be done.
+    IF ( pdims(1) == 1 )  THEN
+       DO  k = 1, nza
+          DO  j = nys, nyna
+             DO  i = nxl, nxra
+                f_out(i,j,k) = work1(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+       RETURN
+    ELSE
+       DO  k = 1, nza
+          DO  j = nys, nyna
+             DO  i = nxl, nxra
+                f_inv(i,j,k) = work1(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- Transpose array
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+    CALL MPI_ALLTOALL( f_inv(nxl,nys,1), sendrecvcount_zx, MPI_REAL, &
+                       work2(1),         sendrecvcount_zx, MPI_REAL, &
+                       comm1dx, ierr )
+    CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!-- Reorder transposed array
+    m = 0
+    DO  l = 0, pdims(1) - 1
+       xs = 0 + l * nnx
+       DO  k = nzb_x, nzt_xa
+          DO  j = nys_x, nyn_xa
+             DO  i = xs, xs + nnx - 1
+                m = m + 1
+                f_out(i,j,k) = work2(m)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
 
-    USE indices,                                                                                   &
-        ONLY:  ny,                                                                                 &
-               nz
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxl_z,                                                                              &
-               nxr_y,                                                                              &
-               nxr_z,                                                                              &
-               nyn_z,                                                                              &
-               nys_z,                                                                              &
-               nzb_y,                                                                              &
-               nzt_y
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  zs  !<
-#endif
-
-    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)  !<
-    REAL(wp) ::  f_out(nxl_z:nxr_z,nys_z:nyn_z,1:nz)  !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-
-!
-!-- If the PE grid is one-dimensional along y, only local reordering of the data is necessary and no
-!-- transposition has to be done.
-    IF ( pdims(1) == 1 )  THEN
-
-       !$OMP PARALLEL PRIVATE ( i, j, k )
-       !$OMP DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_out, f_inv)
-#endif
-       DO  j = 0, ny
-          DO  k = nzb_y, nzt_y
-             DO  i = nxl_y, nxr_y
-                f_out(i,j,k) = f_inv(i,k,j)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP END PARALLEL
-
-    ELSE
-
-#if defined( __parallel )
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(f_inv)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( f_inv(nxl_y,nzb_y,0),  sendrecvcount_yz, MPI_REAL,                       &
-                          work(nxl_z,1,nys_z,0), sendrecvcount_yz, MPI_REAL, comm1dx, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(work)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!--    Reorder transposed array
-       !$OMP PARALLEL PRIVATE ( i, j, k, l, zs )
-       DO  l = 0, pdims(1) - 1
-          zs = 1 + l * ( nzt_y - nzb_y + 1 )
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(f_out, work)
-#endif
-          !$OMP DO
-          DO  j = nys_z, nyn_z
-             DO  k = zs, zs + nzt_y - nzb_y
-                DO  i = nxl_z, nxr_z
-                   f_out(i,j,k) = work(i,k-zs+1,j,l)
-                ENDDO
-             ENDDO
-          ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-       !$OMP END PARALLEL
-#endif
-
-   ENDIF
-
- END SUBROUTINE transpose_yz
-
-
-!--------------------------------------------------------------------------------------------------!
+ END SUBROUTINE transpose_zx
+
+
+ SUBROUTINE transpose_zy( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Resorting data for the transposition from z to x. The transposition itself is carried out in
-!> transpose_zx.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE resort_for_zx( f_in, f_inv )
-
-
-    USE indices,                                                                                   &
-        ONLY:  nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               nz
-
-    USE kinds
+! Transposition of input array (f_in) from z to y. For the input array, all
+! elements along z reside on the same PE, while after transposition, all
+! elements along y reside on the same PE.
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)   !<
-    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-    !$OMP PARALLEL PRIVATE ( i, j, k )
-    !$OMP DO
-#if __acc_fft_device
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-    !$ACC PRESENT(f_in, f_inv)
+    INTEGER ::  i, j, k, l, m, zs
+    
+    REAL ::  f_in(nxl_z:nxr_za,nys_z:nyn_za,1:nza),                     &
+             f_inv(nxl_y:nxr_ya,nzb_y:nzt_ya,0:nya),                    &
+             f_out(0:nya,nxl_y:nxr_ya,nzb_y:nzt_ya),                    &
+             work1(0:nya,nxl_y:nxr_ya,nzb_y:nzt_ya), work2(nnx*nny*nnz)
+
+#if defined( __parallel )
+
+!
+!-- If the PE grid is one-dimensional along y, the array has only to be
+!-- reordered locally and therefore no transposition has to be done.
+    IF ( pdims(1) /= 1 )  THEN
+!
+!--    Reorder input array for transposition
+       m = 0
+       DO  l = 0, pdims(1) - 1
+          zs = 1 + l * ( nzt_ya - nzb_y + 1 )
+          DO  j = nys_z, nyn_za
+             DO  k = zs, zs + nzt_ya - nzb_y
+                DO  i = nxl_z, nxr_za
+                   m = m + 1
+                   work2(m) = f_in(i,j,k)
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDDO
+
+!
+!--    Transpose array
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start' )
+       CALL MPI_ALLTOALL( work2(1),             sendrecvcount_yz, MPI_REAL, &
+                          f_inv(nxl_y,nzb_y,0), sendrecvcount_yz, MPI_REAL, &
+                          comm1dx, ierr )
+       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
+
+!
+!--    Reorder transposed array in a way that the y index is in first position
+       DO  k = nzb_y, nzt_ya
+          DO  i = nxl_y, nxr_ya
+             DO  j = 0, nya
+                work1(j,i,k) = f_inv(i,k,j)
+             ENDDO
+          ENDDO
+       ENDDO
+    ELSE
+!
+!--    Reorder the array in a way that the y index is in first position
+       DO  k = nzb_y, nzt_ya
+          DO  i = nxl_y, nxr_ya
+             DO  j = 0, nya
+                work1(j,i,k) = f_in(i,j,k)
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+!
+!-- Move data to output array
+    DO  k = nzb_y, nzt_ya
+       DO  i = nxl_y, nxr_ya
+          DO  j = 0, nya
+             f_out(j,i,k) = work1(j,i,k)
+          ENDDO
+       ENDDO
+    ENDDO
+
 #endif
-    DO  i = nxl, nxr
-        DO  j = nys, nyn
-            DO  k = 1,nz
-               f_inv(j,i,k) = f_in(k,j,i)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP END PARALLEL
-
- END SUBROUTINE resort_for_zx
-
-
-!--------------------------------------------------------------------------------------------------!
+
+ END SUBROUTINE transpose_zy
+
+
+ SUBROUTINE transpose_zyd( f_in, work1, f_inv, work2, f_out )
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Transposition of input array (f_in) from z to x. For the input array, all elements along z reside
-!> on the same PE, while after transposition, all elements along x reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_zx( f_inv, f_out )
-
+! Transposition of input array (f_in) from z to y. For the input array, all
+! elements along z reside on the same PE, while after transposition, all
+! elements along y reside on the same PE.
+! This is a direct transposition for arrays with indices in regular order
+! (k,j,i) (cf. transpose_zy).
+!------------------------------------------------------------------------------!
+
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE pegrid
+    USE transpose_indices
+
+    IMPLICIT NONE
+
+    INTEGER ::  i, j, k, l, m, ys
+    
+    REAL ::  f_in(1:nza,nys:nyna,nxl:nxra), f_inv(nys:nyna,nxl:nxra,1:nza), &
+             f_out(0:nya,nxl_yd:nxr_yda,nzb_yd:nzt_yda),                    &
+             work1(nys:nyna,nxl:nxra,1:nza), work2(nnx*nny*nnz)
 
 #if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
-
-    USE fft_xy,                                                                                    &
-        ONLY:  f_vec_x,                                                                            &
-               temperton_fft_vec
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  nx,                                                                                 &
-               nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               nz
-
-#if defined( __parallel )
-    USE indices,                                                                                   &
-        ONLY:  nnx
-#endif
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nyn_x,                                                                              &
-               nys_x,                                                                              &
-               nzb_x,                                                                              &
-               nzt_x
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  mm  !<
-    INTEGER(iwp) ::  xs  !<
-#endif
-
-    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)          !<
-    REAL(wp) ::  f_out(0:nx,nys_x:nyn_x,nzb_x:nzt_x)  !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nys_x:nyn_x,nnx,nzb_x:nzt_x,0:pdims(1)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-
-!
-!-- If the PE grid is one-dimensional along y, only local reordering of the data is necessary and no
-!-- transposition has to be done.
-    IF ( pdims(1) == 1 )  THEN
-
-       !$OMP PARALLEL PRIVATE ( i, j, k )
-       !$OMP DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_out, f_inv)
-#endif
-       DO  k = 1, nz
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                f_out(i,j,k) = f_inv(j,i,k)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP END PARALLEL
-
+
+!
+!-- Rearrange indices of input array in order to make data to be send
+!-- by MPI contiguous
+    DO  i = nxl, nxra
+       DO  j = nys, nyna
+          DO  k = 1, nza
+             work1(j,i,k) = f_in(k,j,i)
+          ENDDO
+       ENDDO
+    ENDDO
+
+!
+!-- Move data to different array, because memory location of work1 is
+!-- needed further below (work1 = work2).
+!-- If the PE grid is one-dimensional along x, only local reordering
+!-- of the data is necessary and no transposition has to be done.
+    IF ( pdims(2) == 1 )  THEN
+       DO  k = 1, nza
+          DO  i = nxl, nxra
+             DO  j = nys, nyna
+                f_out(j,i,k) = work1(j,i,k)
+             ENDDO
+          ENDDO
+       ENDDO
+       RETURN
     ELSE
-
-#if defined( __parallel )
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(f_inv)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( f_inv(nys,nxl,1),      sendrecvcount_zx, MPI_REAL,                       &
-                          work(nys_x,1,nzb_x,0), sendrecvcount_zx, MPI_REAL, comm1dx, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(work)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-
-!
-!--    Reorder transposed array.
-!--    Data for the vectorized Temperton-fft is stored in different array format (f_vec_x) which
-!--    saves additional data copy in fft_x.
-       IF ( temperton_fft_vec )  THEN
-
-          DO  l = 0, pdims(1) - 1
-             xs = 0 + l * nnx
-             DO  k = nzb_x, nzt_x
-                DO  i = xs, xs + nnx - 1
-                   DO  j = nys_x, nyn_x
-                      mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
-                      f_vec_x(mm,i) = work(j,i-xs+1,k,l)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDDO
-
-       ELSE
-
-          !$OMP PARALLEL PRIVATE ( i, j, k, l, xs )
-          DO  l = 0, pdims(1) - 1
-             xs = 0 + l * nnx
-#if __acc_fft_device
-             !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-             !$ACC PRESENT(f_out, work)
-#endif
-             !$OMP DO
-             DO  k = nzb_x, nzt_x
-                DO  i = xs, xs + nnx - 1
-                   DO  j = nys_x, nyn_x
-                      f_out(i,j,k) = work(j,i-xs+1,k,l)
-                   ENDDO
-                ENDDO
-             ENDDO
-             !$OMP END DO NOWAIT
-          ENDDO
-          !$OMP END PARALLEL
-
-       ENDIF
-
-#endif
-
-    ENDIF
-
- END SUBROUTINE transpose_zx
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Resorting data after the transposition from z to y. The transposition itself is carried out in
-!> transpose_zy.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE resort_for_zy( f_inv, f_out )
-
-
-    USE indices,                                                                                   &
-        ONLY:  ny
-
-    USE kinds
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxr_y,                                                                              &
-               nzb_y,                                                                              &
-               nzt_y
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)  !<
-    REAL(wp) ::  f_out(0:ny,nxl_y:nxr_y,nzb_y:nzt_y)  !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-    !$OMP PARALLEL PRIVATE ( i, j, k )
-    !$OMP DO
-#if __acc_fft_device
-    !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-    !$ACC PRESENT(f_out, f_inv)
-#endif
-    DO  k = nzb_y, nzt_y
-        DO  i = nxl_y, nxr_y
-            DO  j = 0, ny
-               f_out(j,i,k) = f_inv(i,k,j)
-            ENDDO
-        ENDDO
-    ENDDO
-    !$OMP END PARALLEL
-
- END SUBROUTINE resort_for_zy
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:cpu_log_nowait
-! ------------
-!> Transposition of input array (f_in) from z to y. For the input array, all elements along z reside
-!> on the same PE, while after transposition, all elements along y reside on the same PE.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE transpose_zy( f_in, f_inv )
-
-
-#if defined( __parallel )
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               cpu_log_nowait,                                                                     &
-               log_point_s
-#endif
-
-    USE indices,                                                                                   &
-        ONLY:  ny,                                                                                 &
-               nz
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_y,                                                                              &
-               nxl_z,                                                                              &
-               nxr_y,                                                                              &
-               nxr_z,                                                                              &
-               nyn_z,                                                                              &
-               nys_z,                                                                              &
-               nzb_y,                                                                              &
-               nzt_y
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
-
-#if defined( __parallel )
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  zs  !<
-#endif
-
-    REAL(wp) ::  f_in(nxl_z:nxr_z,nys_z:nyn_z,1:nz)   !<
-    REAL(wp) ::  f_inv(nxl_y:nxr_y,nzb_y:nzt_y,0:ny)  !<
-
-#if defined( __parallel )
-    REAL(wp), DIMENSION(nxl_z:nxr_z,nzt_y-nzb_y+1,nys_z:nyn_z,0:pdims(1)-1) ::  work  !<
-#if __acc_fft_device
-    !$ACC DECLARE CREATE(work)
-#endif
-#endif
-
-!
-!-- If the PE grid is one-dimensional along y, the array has only to be reordered locally and
-!-- therefore no transposition has to be done.
-    IF ( pdims(1) /= 1 )  THEN
-
-#if defined( __parallel )
-!
-!--    Reorder input array for transposition
-       !$OMP PARALLEL PRIVATE ( i, j, k, l, zs )
-       DO  l = 0, pdims(1) - 1
-          zs = 1 + l * ( nzt_y - nzb_y + 1 )
-#if __acc_fft_device
-          !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-          !$ACC PRESENT(work, f_in)
-#endif
-          !$OMP DO
-          DO  j = nys_z, nyn_z
-             DO  k = zs, zs + nzt_y - nzb_y
-                DO  i = nxl_z, nxr_z
-                   work(i,k-zs+1,j,l) = f_in(i,j,k)
-                ENDDO
-             ENDDO
-          ENDDO
-          !$OMP END DO NOWAIT
-       ENDDO
-       !$OMP END PARALLEL
-
-!
-!--    Transpose array
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'start', cpu_log_nowait )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE HOST(work)
-#else
-       !$ACC HOST_DATA USE_DEVICE(work, f_inv)
-#endif
-#endif
-
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLTOALL( work(nxl_z,1,nys_z,0), sendrecvcount_yz, MPI_REAL,                       &
-                          f_inv(nxl_y,nzb_y,0),  sendrecvcount_yz, MPI_REAL, comm1dx, ierr )
-
-#if __acc_fft_device
-#ifndef __cuda_aware_mpi
-       !$ACC UPDATE DEVICE(f_inv)
-#else
-       !$ACC END HOST_DATA
-#endif
-#endif
-
-       CALL cpu_log( log_point_s(32), 'mpi_alltoall', 'stop' )
-#endif
-
-    ELSE
-!
-!--    Reorder the array in the same way like ALLTOALL did it
-       !$OMP PARALLEL PRIVATE ( i, j, k )
-       !$OMP DO
-#if __acc_fft_device
-       !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i,j,k) &
-       !$ACC PRESENT(f_inv, f_in)
-#endif
-       DO  k = nzb_y, nzt_y
-          DO  j = 0, ny
-             DO  i = nxl_y, nxr_y
-                f_inv(i,k,j) = f_in(i,j,k)
-             ENDDO
-          ENDDO
-       ENDDO
-       !$OMP END PARALLEL
-
-    ENDIF
-
- END SUBROUTINE transpose_zy
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Transposition of input array (f_in) from z to y. For the input array, all elements along z reside
-!> on the same PE, while after transposition, all elements along y reside on the same PE. This is a
-!> direct transposition for arrays with indices in regular order (k,j,i) (cf. transpose_zy).
-!--------------------------------------------------------------------------------------------------!
-#if defined( __parallel )
- SUBROUTINE transpose_zyd( f_in, f_out )
-
-
-    USE cpulog,                                                                                    &
-        ONLY:  cpu_log,                                                                            &
-               log_point_s
-
-    USE indices,                                                                                   &
-        ONLY:  nnx,                                                                                &
-               nny,                                                                                &
-               nnz,                                                                                &
-               nxl,                                                                                &
-               nxr,                                                                                &
-               nyn,                                                                                &
-               nys,                                                                                &
-               ny,                                                                                 &
-               nz
-
-    USE kinds
-
-    USE pegrid
-
-    USE transpose_indices,                                                                         &
-        ONLY:  nxl_yd,                                                                             &
-               nxr_yd,                                                                             &
-               nzb_yd,                                                                             &
-               nzt_yd
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i   !<
-    INTEGER(iwp) ::  j   !<
-    INTEGER(iwp) ::  k   !<
-    INTEGER(iwp) ::  l   !<
-    INTEGER(iwp) ::  m   !<
-    INTEGER(iwp) ::  ys  !<
-
-    REAL(wp) ::  f_in(1:nz,nys:nyn,nxl:nxr)               !<
-    REAL(wp) ::  f_inv(nys:nyn,nxl:nxr,1:nz)              !<
-    REAL(wp) ::  f_out(0:ny,nxl_yd:nxr_yd,nzb_yd:nzt_yd)  !<
-    REAL(wp) ::  work(nnx*nny*nnz)                        !<
-
-!
-!-- Rearrange indices of input array in order to make data to be send by MPI contiguous.
-    DO  i = nxl, nxr
-       DO  j = nys, nyn
-          DO  k = 1, nz
-             f_inv(j,i,k) = f_in(k,j,i)
-          ENDDO
-       ENDDO
-    ENDDO
-
-!
-!-- Move data to different array, because memory location of work1 is needed further below
-!-- (work1 = work2). If the PE grid is one-dimensional along x, only local reordering of the data is
-!-- necessary and no transposition has to be done.
-    IF ( pdims(2) == 1 )  THEN
-       DO  k = 1, nz
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                f_out(j,i,k) = f_inv(j,i,k)
-             ENDDO
-          ENDDO
-       ENDDO
-       RETURN
+       DO  k = 1, nza
+          DO  i = nxl, nxra
+             DO  j = nys, nyna
+                f_inv(j,i,k) = work1(j,i,k)
+             ENDDO
+          ENDDO
+       ENDDO
     ENDIF
 
